
#ifndef _CFG_H_
#define _CFG_H_

#include "version.h"

//#define POOR_GRAPH     //uncomment to get ugly but ASCII tree lines in human readable output files
//#define UTF8_GRAPH     //uncomment to get UTF-8 (note that the input text is supposed to be utf-8 encoded, too)
#define VERBOSE        //uncomment to get verbose output 
#define STATISTICS     //uncomment to enable hash table statistics gathering
#define PROGRESS_LOG   //uncomment to enable progress logging (I_loss, words merged, etc.)
#define DEBUG          //uncomment to enable debugging and invariant guarding code
typedef double F;      //float for all computations
typedef float FF;      //float for I_loss table
const F oversize=1.8;  //hash table will be alloced 1+oversize times bigger than needed (recommended oversize>1)
                       //this makes searching faster, especially the search for non-present elements
                       //note however, that it prolongs I_loss() computation sice it traverses all the entries of the (selected) hash tables.
const int rehash_trigger=5; //whenever hash table uses less than 1/rehash_trigger space
                            //it is rehashed such that it will use 1/(1+oversize) of the allocated space.
#endif



