
/* ----- this file comes from `daves_core' package
 */
 

  //!!!!!! predelat floor a round !!!!

#ifndef INC_H
#define INC_H

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <float.h>
#include <limits.h>

#ifdef DEBUG
  #define DBG(x) x
#else
  #define DBG(x)
#endif

#define UNUSED __attribute__((unused))
#define NORETURN __attribute__((noreturn))
#define PUREFN __attribute__((const))
#define REGPARM(nr) __attribute__((regparm(nr)))
#define SECTION(name) __attribute__((section(name)))
#define FORMAT(str_idx, first_chk) __attribute__((format(printf,str_idx, first_chk)))
#define ALIGN(a) __attribute__((packed, aligned(a)))
#define PACKED __attribute__((packed))

#ifndef OPTIMIZE
  #undef REGPARM
  #define REGPARM(nr)
#endif

typedef signed long int ix;   //this is the type which changes its size according to the machine to either 32 bits or to 64 bits. Therefore it is suitable for indexing arrays, holdning pointers etc.
typedef unsigned long int ux; //this is its unsigned version
typedef unsigned char ch;     //the rest of the integer types are fixed
typedef unsigned char u8;
typedef signed char i8;
typedef short int i16;
typedef int i32;
typedef long long int i64;
typedef unsigned long long int u64;
typedef unsigned int u32;
typedef unsigned short int u16;

#define I32_MAX i32((u32(1)<<31)-1)
#define U32_MAX u32(-1)
#define I64_MAX i64((u64(1)<<63)-1)
#define U64_MAX u64(i64(-1))

#ifndef PI
 #ifdef M_PI
   #define PI M_PI
 #else
   #define PI 3.1415926535897932384626433832795029
 #endif
#endif
#define PIl 3.1415926535897932384626433832795029L

inline int bitlog(u32 x)
{
  int i=-1;
  for(; x; x>>=1) i++;
  return i;
}

inline u32 bitrev16(u32 x)
{
  x=(x>>1)&0x5555 | (x<<1)&0xAAAA;
  x=(x>>2)&0x3333 | (x<<2)&0xCCCC;
  x=(x>>4)&0x0F0F | (x<<4)&0xF0F0;
  x=(x<<8)&0xFFFF | (x>>8);
  return x;
}

inline u32 bitrev32(u32 x)
{
  x=(x>>1)&0x55555555 | (x<<1)&0xAAAAAAAA;
  x=(x>>2)&0x33333333 | (x<<2)&0xCCCCCCCC;
  x=(x>>4)&0x0F0F0F0F | (x<<4)&0xF0F0F0F0;
  x=(x>>8)&0x00FF00FF | (x<<8)&0xFF00FF00;
  x=(x>>16) | (x<<16);
  return x;
}

// min, max, sqr, swap

#if __GNUC__<=3
  #define _mmin(x,y) ((x)<?(y))
  #define _mmax(x,y) ((x)>?(y))
#else
  #define _mmin(x,y) ({typeof(x) tx=(x); typeof(y) ty=(y); tx<ty ? tx : ty;})
  #define _mmax(x,y) ({typeof(x) tx=(x); typeof(y) ty=(y); tx>ty ? tx : ty;})
#endif

template <class H> inline H min(H x, H y) {return _mmin(x,y);}
template <class H> inline H max(H x, H y) {return _mmax(x,y);}

template <class H> inline H max(H a, H b, H c)
{ return max (a, max (b, c));}

template <class H> inline H min(H a, H b, H c)
{ return min (a, min (b, c));}

template <class H> inline void swap (H& a, H& b)
{ H c; c=a; a=b; b=c; }

template <class H> inline H sqr(H x) { return x*x;}
inline float       ufrexp(float m, int *e)       { return frexpf(m,e); }
inline double      ufrexp(double m, int *e)      { return frexp(m,e);  }
inline long double ufrexp(long double m, int *e) { return frexpl(m,e); }
inline float       uldexp(float m, int e)        { return ldexpf(m,e); }
inline double      uldexp(double m, int e)       { return ldexp(m,e);  }
inline long double uldexp(long double m, int e)  { return ldexpl(m,e); }
inline float       ulog(float x)       { return logf(x);}
inline double      ulog(double x)      { return log(x);}
inline long double ulog(long double x) { return logl(x);}
template <class F> inline F ulog2(F x)  { return ulog(x)/ulog(F(2)); }
template <class F> inline F ulog10(F x) { return ulog(x)/ulog(F(10)); }
inline float       uexp(float x)       { return expf(x);}
inline double      uexp(double x)      { return exp(x);}
inline long double uexp(long double x) { return expl(x);}
inline float       ucos(float x)       { return cosf(x);}
inline double      ucos(double x)      { return cos(x);}
inline long double ucos(long double x) { return cosl(x);}
inline float       usin(float x)       { return sinf(x);}
inline double      usin(double x)      { return sin(x);}
inline long double usin(long double x) { return sinl(x);}
inline float       uatan2(float x, float y)             { return atan2f(x,y); }
inline double      uatan2(double x, double y)           { return atan2(x,y);  }
inline long double uatan2(long double x, long double y) { return atan2l(x,y); }
inline float       uatan(float x)       { return atanf(x); }
inline double      uatan(double x)      { return atan(x);  }
inline long double uatan(long double x) { return atanl(x); }
inline float       usqrt(float x)       { return sqrtf(x); }
inline double      usqrt(double x)      { return sqrt(x);  }
inline long double usqrt(long double x) { return sqrtl(x); }
inline float       uerf(float x)       { return erff(x); }
inline double      uerf(double x)      { return erf(x);  }
inline long double uerf(long double x) { return erfl(x); }
inline float       uerfc(float x)       { return erfcf(x); }
inline double      uerfc(double x)      { return erfc(x);  }
inline long double uerfc(long double x) { return erfcl(x); }
inline float       pwr(float x, float y)             { return powf(x,y); }
inline double      pwr(double x, double y)           { return pow(x,y);  }
inline long double pwr(long double x, long double y) { return powl(x,y); }
inline float       sgn(float x)       { return (x!=0) ? copysignf(1,x) : 0; }
inline double      sgn(double x)      { return (x!=0) ? copysign(1,x)  : 0; }
inline long double sgn(long double x) { return (x!=0) ? copysignl(1,x) : 0; }
inline int         isgn(float x)       { return (x!=0) ? int(copysignf(1,x)) : 0; }
inline int         isgn(double x)      { return (x!=0) ? int(copysign(1,x))  : 0; }
inline int         isgn(long double x) { return (x!=0) ? int(copysignl(1,x)) : 0; }
inline float       uabs(float x)       { return fabsf(x);}
inline double      uabs(double x)      { return fabs(x);}
inline long double uabs(long double x) { return fabsl(x);}
inline int is_mepsilon(float eps, float norm)   { return uabs(eps)+norm < nextafterf(norm,FLT_MAX); }
inline int is_mepsilon(double eps, double norm) { return uabs(eps)+norm < nextafter(norm,DBL_MAX); }
inline int is_mepsilon(long double eps, long double norm) { return uabs(eps)+norm < nextafterl(norm,LDBL_MAX); }
inline float       times_machine_epsilon(float x) {return x*FLT_EPSILON;}
inline double      times_machine_epsilon(double x) {return x*DBL_EPSILON;}
inline long double times_machine_epsilon(long double x) {return x*LDBL_EPSILON;}
inline int uisnan(float x)        { return isnanf(x);}
inline int uisnan(double x)       { return isnan(x);}
inline int uisnan(long double x)  { return isnanl(x);}
inline int uisinf(float x)        { return isinff(x);}
inline int uisinf(double x)       { return isinf(x);}
inline int uisinf(long double x)  { return isinfl(x);}
template <class T> inline int is_near(T a, T b, int eps_mult) { return uabs(a-b) < times_machine_epsilon(uabs(a+b)*eps_mult); }
inline float        F_tiny(float _) {return FLT_MIN;}
inline double       F_tiny(double _) {return DBL_MIN;}
inline long double  F_tiny(long double _) {return LDBL_MIN;}
inline float       F_max(float _) {return FLT_MAX;}
inline double      F_max(double _) {return DBL_MAX;}
inline long double F_max(long double _) {return LDBL_MAX;}
inline i8  sgn(i8 x)  { return (1+((x>>7)<<1))  & ((x|-x)>>7); }
inline i16 sgn(i16 x) { return (1+((x>>15)<<1)) & ((x|-x)>>15); }
inline i32 sgn(i32 x) { return (1+((x>>31)<<1)) & ((x|-x)>>31); }
inline i64 sgn(i64 x) { return (1+((x>>63)<<1)) & ((x|-x)>>63); }
inline int isaturate(i64 x){
  int high=int(x>>32);
  if(!high) return x;
  else if(high>0) return INT_MAX;
  else return INT_MIN;
}


inline float pythag(float a, float b)
{
  float absa=uabs(a);
  float absb=uabs(b);
  if(absa>absb)     return absa*sqrt(1.0+sqr(absb/absa));
  else if (absb!=0) return absb*sqrt(1.0+sqr(absa/absb));
  else              return 0;
}

inline double pythag(double a, double b)
{
  double absa=uabs(a);
  double absb=uabs(b);
  if(absa>absb)     return absa*sqrt(1.0+sqr(absb/absa));
  else if (absb!=0) return absb*sqrt(1.0+sqr(absa/absb));
  else              return 0;
}

inline double pythag(long double a, long double b)
{
  long double absa=uabs(a);
  long double absb=uabs(b);
  if(absa>absb)     return absa*sqrt(1.0+sqr(absb/absa));
  else if (absb!=0) return absb*sqrt(1.0+sqr(absa/absb));
  else              return 0;
}

inline int ifloor(long double x) {return int(floorl(x));}
inline int ifloor(double x) {return int(floor(x));}
inline int ifloor(float x) {return int(floorf(x));}
inline i64 iifloor(long double x) {return i64(floorl(x));}
inline i64 iifloor(double x) {return i64(floor(x));}
inline i64 iifloor(float x) {return i64(floorf(x));}

inline int iround(float x) {return ifloor(x+0.5);}
inline int iround(double x) {return ifloor(x+0.5);}
inline int iround(long double x) {return ifloor(x+0.5);}
inline i64 iiround(float x) {return iifloor(x+0.5);}
inline i64 iiround(double x) {return iifloor(x+0.5);}
inline i64 iiround(long double x) {return iifloor(x+0.5);}

inline float fract(float x) {return x - floorf(x);}
inline double fract(double x) {return x - floor(x);}
inline long double fract(long double x) {return x - floorl(x);}

inline int rnd (int space) { return int( (i64)(rand())*space/RAND_MAX );}
inline float rnd (float from, float to) { return float(rand())*(to-from)/RAND_MAX + from;}
inline double rnd (double from, double to) { return double(rand())*(to-from)/RAND_MAX + from;}
inline long double rnd (long double from, long double to) { return (long double)(rand())*(to-from)/RAND_MAX + from;}

inline void outofmem() {printf("out of memory !\n"); exit(-1);}

template <class H> inline H* fill(H* dest, H value, int len)
{
  for (int i=0; i<len; i++) dest[i] = value;
  return dest;
}

inline char* fill(char *dest, char val, int len)
{ return (char*) memset (dest, val, len);}

inline i8* fill(i8 *dest, i8 val, int len)
{ return (i8*) memset (dest, val, len);}

template <class H> inline H* copy (H* dest, H* src, int len)
{ return (H*)memcpy(dest, src, len*sizeof(H));}

inline void copy_forward(char* dest, char* src, int len)
{  //!!!!! zrychlit a overit v disassembleru
  while(len--)
    *dest++=*src++;
}

template <class H> inline void copy_fwd(H* dest, H* src, int len)
{ copy_forward((char*)dest, (char*)src, sizeof(H)*len); }

template <class H> inline H* move (H* dest, H* src, int len)
{ return (H*)memmove(dest, src, len*sizeof(H));}

template <class H> inline void alloc (H* &ptr, int len=1)
{	
  ptr = (H*)malloc(sizeof(H)*len);
  if (!ptr) outofmem();
}

template <class H> inline void c_alloc (H* &ptr, int len=1)
{	
  ptr = (H*)calloc(sizeof(H)*len, 1);
  if (!ptr) outofmem();
}

template <class H> inline void resize (H* &ptr, int len)
{
  if (ptr) 
  { ptr = (H*)realloc(ptr, sizeof(H)*len);
    if (!ptr) outofmem();
  }
  else
    alloc (ptr, len);
}

//can be called more than once on the same pointer
template <class H> inline void dispose (H* & ptr)
{
  if (ptr) free(ptr);
  ptr = NULL;
}

inline int is_in_range(int x, int low, int high)
{
  return (~((x-low)>>31)) & ((x-high-1)>>31);
}

/* if string `pref' is a prefix of `base' it returns base+strlen(pref)
 * if not, it returns NULL.
 */
inline char* is_prefix(char *pref, char* base)
{
  for(;*pref && *pref==*base; pref++) base++;
  if(*pref==0) return base;
  else return 0;
}

/* Declares version of heap sort function to be used to sort arrays of type
 * T. It can be used in two different ways. Either we can have array of T
 * (where T is for some struct{} for example), or we can sort array of T=Q*,
 * that is array of pointers to Q. The first way is more convenient when
 * sorting array of numbers, the second way is prefferable for sorting of
 * the array of large structures, since it makes data movement independent
 * of sizeof(Q) and further allows the sorting permutation to be recovered
 * from the pointers. Note that sorting by the first method requires the
 * copy constructor for T to exist.
 * 
 * CMP is comparing expression (of type int) containg `high' and `low' of
 * type T. If high>low, it should return >0, if high==low it should return
 * 0, otherwise <0. It should not be using any of the global variables and
 * any of the variables contained in hsort() function. However, in case of
 * T=Q*, it can use address information of pointers high and low to force
 * stability of hsort as will be shown in the example below. Sorting is done
 * 'in-situ' so no other memory is needed (not even a stack as in case of
 * qsort). The array will be sorted in an ascending order.
 * 
 * CAUTION: since there is a sentinel used in the algorithm, it is extremely
 *          important that CMP of identical elements returns 0 (==). You can
 *          use fake < instead of == only on elements which are different if
 *          you want to enforce stability. Note also, that expressions
 *          &high, &low (address of) are forbidden in CMP, since high and
 *          low reffer to the element stored in the temporary area, not in
 *          the array.
 *
 * Examples: sorting of integers:
 *              DECLARE_hsort(int, high-low)
 *            or
 *              DECLARE_hsort(int*, (*high-*low))
 *           stable sorting of strings:
 *              DECLARE_hsort(char*, (2*sgn(strcmp(high,low)) + sgn(int(high-low))))
 *            or
 *              DECLARE_hsort(char**, (2*sgn(strcmp(*high,*low)) + sgn(int(high-low))))
 *
 */
#define _CMP_(CMP,T,h,l) {T high=(h); T low=(l); C=(CMP);}
#define DECLARE_hsort(T, CMP) DECLARE_nhsort(hsort, T, CMP)
#define DECLARE_nhsort(name, T, CMP) \
void name(T* a, int n)                                        \
{                                                             \
  if (n<2) return;                                            \
  int C;                                                      \
  a--; /*now the indexes are 1:n */                           \
  for(int p=(n-1)>>1; p>0; p--){ /*build the heap*/           \
    T t=a[p]; T h; T l;                                       \
    int i=p;                                                  \
    do{                                                       \
      i<<=1;                                                  \
      h=a[i], l=a[i+1];                                       \
      _CMP_(CMP,T,h,l); if(C<0) {i++; h=l;}                   \
      _CMP_(CMP,T,h,t); if(C<=0) {i>>=1; break;}              \
      a[i>>1]=h;                                              \
    }while(i<=((n-1)>>1));                                    \
    a[i]=t;                                                   \
  } /*holds here: if n&1 then a[1:n] is the heap else a[1:n-1] is the heap*/                 \
  if(!(n&1)) {_CMP_(CMP,T,a[1],a[n]); if(C<0) swap(a[1],a[n]);} /*to ensure that extracted max will be greater then the replacement element (in a[1:n-1]-heap case) */ \
  for(int p=n; p>2; p--){  /*sort it*/                                                       \
    T b=a[p];  /*let it in a[p] as a sentinel for heap extract_max (in case of p is even)*/  \
    T m=a[1];                                                 \
    int i=2;                                                  \
    do{  /*holds here: i is even and i<p */                   \
      T h=a[i]; T l=a[i+1];                                   \
      _CMP_(CMP,T,h,l); if(C<=0) {i++; h=l;}                  \
      _CMP_(CMP,T, b,h); if(C>=0) break; /*'==' because of sentinel*/ \
      a[i>>1]=h;                                              \
      i*=2;                                                   \
    }while(i<p);                                              \
    a[p]=m;                                                   \
    a[i>>1]=b;                                                \
  }                                                           \
  swap(a[1],a[2]);                                            \
}

#endif


