// >>>>> mmi_clustering_0.cc

#include "base.cc"

/*
 * Naive implementation intended for debugging
 */

#define c(y,x) c[A*(y)+(x)]

int *c_map;
int C;
int A;
int N;

F I(i32* c)
{
  int cy[A], cx[A]; fill(cy,0,A); fill(cx,0,A);
  for(int y=0; y<A; y++) for(int x=0; x<A; x++){
    int t=c(y,x);
    cy[y]+=t;
    cx[x]+=t;
  }
  F acc=0;
  for(int y=0; y<A; y++) for(int x=0; x<A; x++){
    F cyx=c(y,x);
    if(cyx>0) acc+=cyx*ulog2(F(cy[y])*cx[x]/(N*cyx));
  }
  return -acc/N;
}

void merge(i32* c, int ll, int rr)
{
  int l=c_map[ll], r=c_map[rr];
  for(int y=0; y<A; y++){
    c(y,l)+=c(y,r);
    c(y,r)=0;
  }
  for(int x=0; x<A; x++){
    c(l,x)+=c(r,x);
    c(r,x)=0;
  }
int s=0; 
for(int x=0; x<A; x++) for(int y=0; y<A; y++) s+=c(y,x);
//printf(" s= %d \n", s);

}

F I_loss(i32* c, int ll, int rr)
{
  i32 cm[A*A]; copy(cm,c,A*A); merge(cm, ll, rr);
  return I(c)-I(cm);
}

void mmi_clustering_0(i32* w0, i32* w1, int NN, int T, mmi_result &ret)
{
  STAT(int start_time=time(0);)
  
  A=0; N=NN;
  for(int k=0; k<N; k++) {
    if(w0[k]>A) A=w0[k];
    if(w1[k]>A) A=w1[k];
  }
  A++;  
  i32 c[A*A]; fill(c,0,A*A);
  for(int k=0; k<N; k++) c(w0[k],w1[k])++;
  ret.I=I(c);
  int ct[A]; fill(ct, 0, A);
  for(int k=0; k<N; k++) {ct[w0[k]]++; ct[w1[k]]++;}
  C=0; for(int a=0; a<A; a++) if(ct[a]>=2*T) C++;
  alloc(c_map,C);
  for(int a=0,i=0; a<A; a++) if(ct[a]>=2*T) c_map[i++]=a;
  printf("Just built the table A=%d C=%d N=%d\n",A,C,N);
  int out_map[C]; copy(out_map, c_map, C);
  tree t000; t000.l=0; t000.r=0; t000.level=0;
  alloc(ret.forest, A+C-1); fill(ret.forest, t000, A);
  alloc(ret.loss, C-1);  

  FF losstab [C*C];
  for(int n=A; n<A+C-1; n++){
    FF min_loss=F_max(FF(1));
    int l=0, r=1;
    for(int y=0; y<C; y++) if(c_map[y]>0) for(int x=y+1; x<C; x++) if(c_map[x]>0){
      FF loss=losstab[y*C+x]=I_loss(c,y,x);
      if(min_loss>loss){
        l=y; r=x; min_loss=loss;
      }
    }
printf(" MERGING %d %d\n", c_map[l], c_map[r]);
    merge(c,l,r); c_map[r]=0;
//for(int y=1; y<A; y++) for(int x=1; x<A; x++) printf(" (%d %d) %d\n", y, x, c(y,x));
    ret.forest[n].l=out_map[l]; ret.forest[n].r=out_map[r]; ret.loss[n-A]=min_loss;

//for(int x=1; x<C; x++) if(c_map[x]>0) for(int y=0; y<x; y++) if(c_map[y]>0)
//printf("x=%3d y=%3d  %19.16f \n", x,y, D(losstab[y*C+x]));
    out_map[l]=n;
  }  
  
  VERB(printf("mmi_clustering_0(): Finished in %d seconds", int(time(0))-start_time));
  ret.A=A; ret.B=0; ret.C=C;  
}


#undef c
