// >>>>> mmi_clustering_4.cc

/* void mmi_clustering_4(i32* w0, i32* w1, int N, int T, mmi_result &ret)
 *
 * classes are being made from w1, where w0 is predicted according to model
 *  k (P(w0[k]|C(w0[k])) * P(C(w0[k])|C(w1[k])))
 */


#include "base.cc"
#define BLOCKSIZE 8192   //blocksize (number of triples) used when loading files

STAT(i64 h_collision__4=0; i64 h_access__4=0; i64 h_rehash__4=0; i64 h_alloced_entries__4=0;)

struct entry__4{
  i32 key, data;  //valid keys range from 1 to (1<<31)-2 (inclusively). 0 is used to mark free space
};                //and negative values mark "deleted" entries. Value (1<<31)-1 is a sentinel which prevents writing into the empty hash

static entry__4 void_entry__4={i32(u32(1<<31)-1),-1};  //this is used as a "dummy" entry for zero-length hashes

struct hash__4{   /* NOTE: It is possible to have a zero-legth hash. In that case you must not */
  entry__4 *a;    /* write any data into it. It is safe not to call `done()' or destructor on empty hashes. */
  int occupied;   /* Empty hash can be recognized by L==-1 */
  int L;          /* L>0          ... length of the allocated space
                   * L==-1        ... the length of the hash is 0 (implies a=&void_entry__4, occupied=0)
                   * L==0 || L<-1 ... never happens
                   */  
  void init(F oversize, int n){     //note that it can be called with n==0
    if(n>2) n=iround((1+oversize)*n);
    else if(n==0) {init(); return;}
    occupied=0; L=n; alloc(a,n); fill(a, ((entry__4){0,0}), n);
    STAT(h_alloced_entries__4+=n;)
  }
  void init() {   //init() creates empty (but valid) hash
    L=-1;         //so that key%L would work (key%-1==0 for any key (for i32%i32))
    occupied=0;
    a=&void_entry__4;
  }
  void done() { if(L>0) {free(a); STAT(h_alloced_entries__4-=L;) init();} }
  hash__4() { init(); }
  inline void move(hash__4& from) {a=from.a; occupied=from.occupied; L=from.L; from.init();}  /* move-constructor */
  ~hash__4() { done(); }
  entry__4* hash_qry0(i32 key){
    DBG(if(!a) {error("Internal error in hash_qry(): use of uninitialized hash!!");})
    STAT(h_access__4++;)
    i32 idx=key%L;    //note that valid is key is >0 and for L==-1 we need to get 0
    i32 k=a[idx].key;
    if(k==key || k==0) return &a[idx];
    i32 idx2=(key^0x7fffffff)%L; //for L=-1 we need to get 0, otherwise for valid keys we need non-negative number
 //nahradit spis nejakou permutaci bitu a treba vzajemnym xorovanim bitu
    idx=idx2;
    i32 idxf=-1;
    do{
      STAT(h_collision__4++;)
      k=a[idx].key;
      if(k==key || k==0) return &a[idx];
      if(k<0 && idxf<0) idxf=idx;
      idx=(idx+1)%L;
    }while(idx!=idx2);
    if(idxf>=0) return &a[idxf];
    return 0;
  }
  inline entry__4* hash_qry(i32 key){
    DBG(if(key<=0 || key==i32(u32(1<<31)-1)) error("Internal error in hash_qry(): invalid key=%d used", key);)
    entry__4* p=hash_qry0(key);
    DBG(if(p!=0){if(L==-1) error("Internal error in hash_qry(): L=-1 but hash_qry(%d)=%p", key, p);
                 else if(L>0 && (p-a<0 || p-a>L)) error("Internal error in hash_qry(): p-a=%d,L=%d %p %p",p-a, L, p, a);}
        else if(L==0 || L<-1) error("Internal error in hash_qry(): L=%d", L);)
    return p;
  }
  i32 hash_data(i32 key){   //to be used for data reading, non-present entry returns 0    
    i32 idx=key%L;          //equivalent to {p=hash_qry(key); return p?(p->key>0?p->data:0):0;}
    DBG(if(!a) {error("Internal error in hash_data(): use of uninitialized hash!!");})
    STAT(h_access__4++;)
    i32 k=a[idx].key;
    if(k==key) return a[idx].data;
    if(k==0) return 0;
    i32 idx2=(key^0x7fffffff)%L;
    idx=idx2;
    do{
//if(L==-1)   printf("k=%d key=%d idx=%d idx2=%d\n", k, key, idx, idx2);
      STAT(h_collision__4++;)
      k=a[idx].key;
      if(k==key) return a[idx].data;
      if(k==0) return 0;
      idx=(idx+1)%L;
//printf("idx=%d  idx2=%d  key=%d L=%d\n", idx, idx2, key, L); ///tady asi je chybta !!!!!!  
// zasekne se na idx=0  idx2=-3  key=2
    }while(idx!=idx2);
    return 0;
  }
  inline void hash_ins(entry__4* he, i32 key, i32 data) {occupied++; he->key=key; he->data=data;}
  inline void hash_del(entry__4* he) {occupied--; he->key=-1;}
  void rehash(F oversize){
    STAT(h_rehash__4++;)
    entry__4* b=a;
    int LL=L;
    init(oversize, occupied);
    for(int p=0; p<LL; p++){
      i32 k=b[p].key;
      if(k>0){
        entry__4* he=hash_qry(k);
        DBG(if(!he) error("Internal error in rehash(): out of prealloced space!!");)
        hash_ins(he, k, b[p].data);
      }
    }
    if(LL>0){
      free(b);  /* free it, provided it was non-empty hash */
      STAT(h_alloced_entries__4-=LL;)
    }
  }
};

STAT(i64 h_collision_build1__4; i64 h_access_build1__4; i64 h_size1__4; i64 h_hmem1__4;)
STAT(i64 h_collision_build2__4; i64 h_access_build2__4; i64 h_size2__4; i64 h_hmem2__4; i64 h_omem2__4;)

struct line__4{
  i32 map;
  i32 a,b;
  F Q;      /*  a=0  b=0  =>  Q=0 */
};

struct ctab__4{
  hash__4* c;
  int A,   //1+(number of words in the dictionary)
      B,   //number of unique bigrams
      C;   //window length
  i64 N;   //length of input text (number of bigrams seen)
  i32* c_map;
  i32* alias;
  i32* epoch_guard;
  i32 epoch_ct;
  i32** x_walk;
  i32* x_walk_size;
  i32 *c0, *c1;   //c0 .. y (left word),  c1 .. x (right word) OVERIT!!!!
  i32 *yc;  //only used when building the table
  F *Rc0, *Rc1;
  F I;

#ifdef STATISTICS
  i64 htab_memory() { return sizeof(entry__4)*h_alloced_entries__4 + 
                             sizeof(hash__4)*A; }
  i64 other_memory() { 
    i64 acc=sizeof(i32)*A   // alias
           +sizeof(i32)*A   // epoch_guard
           +sizeof(i32)*C   // c_map
           +sizeof(i32*)*C  // x_walk
           +sizeof(i32)*C   // x_walk_size
           +sizeof(i32)*2*C // c0 and c1
           +sizeof(F)*2*C   // Rc0 and Rc1
           +sizeof(ctab__4);
    for(int k=0; k<C; k++)
      acc+=sizeof(i32)*x_walk_size[k];
    return acc;
  }
#endif

  i32 live(i32 y){
    i32 z=y; 
    if(alias[z]!=z){
      do{z=alias[z];}while(alias[z]!=z);
      do{i32 y1=alias[y]; alias[y]=z; y=y1;} while(alias[y]!=y);
    }
    return z;
  }   
  
  ~ctab__4(){
    for(int k=0; k<A; k++) c[k].done();
    free(c); free(c_map);
    for(int k=0; k<C; k++) dispose(x_walk[k]); 
    if(C>0){ //don't free them if we are destructing partially initialized ctab
      free(x_walk); free(x_walk_size);
      free(epoch_guard); free(alias);
      free(Rc0); free(Rc1);
    }
    free(c0); free(c1); dispose(yc);
    STAT(if(h_alloced_entries__4!=0) error("ctab__4(): Internal error: memory leak of %Ld bytes\n", h_alloced_entries__4*sizeof(entry__4));)
  }

  void init_ctab(i32 A0){ 
    A=A0+1; N=0; C=0; yc=0;
    alloc(c,A); for(int a=0; a<A; a++) c[a].init();
    alloc(c0,A); fill(c0,i32(0),A);
    alloc(c1,A); fill(c1,i32(0),A);
    STAT(h_collision__4=0; h_access__4=0;)
  }

  void acc_tab(i32* yxl, int L, F oversize, i32* ysize){
    for(int k=0; k<L; k++){
      i32 y=yxl[3*k], x=yxl[3*k+1], l=yxl[3*k+2];
      if(c[y].L<0) c[y].init(oversize, ysize[y]);
      entry__4* p=c[y].hash_qry(x);
      DBG(if(!p) error("build_tab: Internal error, out of space, y=%d,x=%d,l=%d, c[y].L=%d, c[y].occupied=%d, ysize[y]=%d c[y].a[0].key=%d c[y].a[1].key=%d\n", y,x,l,c[y].L,c[y].occupied, ysize[y], c[y].a[0].key, c[y].a[1].key);)
      if (p->key<=0) c[y].hash_ins(p,x,i32(0));
      p->data+=l;
    }
  }

  void acc_marginals(i32* yxl, int L){
    for(int k=0; k<L; k++){
      i32 ct=yxl[3*k+2];
      if(ct<1 || ct>1000000) error("invalid count encountered (%d)",ct);
      i32 w=yxl[3*k]; if(w<1 || w>A) error("invalid left word with code %d (A=%d) encountered", w,A); 
      c0[w]+=ct;
      if(c0[w]<0) error("too many occurences of left word %d", w);
      w=yxl[3*k+1]; if(w<1 || w>A) error("invalid right word with code %d (A=%d) encountered", w,A); 
      c1[w]+=ct;
      if(c1[w]<0) error("too many occurences of right word %d", w);
      N+=ct;
    }
  }

  void determine_useful_size(){
    STAT(h_collision_build1__4=h_collision__4; h_access_build1__4=h_access__4; 
         h_size1__4=h_alloced_entries__4; h_hmem1__4=htab_memory();)
    alloc(yc,A);
    for(int a=0; a<A; a++) yc[a]=c[a].occupied;
    for(int a=0; a<A; a++) c[a].done(); //delete the table now
    STAT(if(h_alloced_entries__4!=0) error("ctab__4(): Internal error: memory leak of %Ld bytes\n", h_alloced_entries__4*sizeof(entry__4));
         h_collision__4=0; h_access__4=0;)
  }

  void finish_ctab_init(int W)
  {
    STAT(h_collision_build2__4=h_collision__4; h_access_build2__4=h_access__4; h_size2__4=h_alloced_entries__4;)
    STAT(h_collision__4=0; h_access__4=0; h_rehash__4=0;)
    dispose(yc);
    B=0; for(int a=1; a<A; a++) B+=c[a].occupied;
    if(B==0) error("NINO! (no input - no output)");

    alloc(epoch_guard, A); epoch_ct=0;
    alloc(alias, A); for(int a=0; a<A; a++) alias[a]=a;

    C=min(W,A-1);
    int inv_c_map[A]; fill(inv_c_map, -1, A);    
    alloc(c_map,C);    
    for(int a=1,i=0; i<C; a++) {c_map[i]=a; inv_c_map[a]=i; i++;}  //tohle zde pak nebude, bude to mnohem slozitejsi
    
    alloc(x_walk,C); alloc(x_walk_size, C);
    {
      int ct[C]; fill(ct,0,C);
      for(int y=1; y<A; y++) for(int p=0; p<c[y].L; p++){  //we can get here only if c[y].L>0 which is iff c[y]-th hash table is non-empty
        int x=c[y].a[p].key;
        if(x>0 && inv_c_map[x]>=0) ct[inv_c_map[x]]++;
      }
      for(int k=0; k<C; k++){
        alloc(x_walk[k],ct[k]);
        x_walk_size[k]=ct[k];
      }
    }
//printf("N=%lld A=%d\n", N, A);
    int last[C]; fill(last,0,C);
    I=0;
    for(int y=1; y<A; y++) for(int p=0; p<c[y].L; p++) {  //we can get here only if c[y].L>0, which is iff c[y]-th hash table is non-empty
      entry__4* e=&(c[y].a[p]);
      i32 x=e->key;
      if(x>0){
        i32 cyx=e->data;
        I-=cyx*ulog2( F(c0[y])*c1[x] / (F(N)*cyx) );
        int xx=inv_c_map[x];
        if(xx>=0) x_walk[xx][last[xx]++]=y;
      }
    }
    I/=N;
    i32* cw0=c0, *cw1=c1;
    alloc(c0,C); alloc(c1,C); alloc(Rc0,C); alloc(Rc1,C);
    for(int k=0; k<C; k++){
      c0[k]=cw0[c_map[k]]; Rc0[k]=R(c0[k]);
      c1[k]=cw1[c_map[k]]; Rc1[k]=R(c1[k]);
    }
    free(cw0); free(cw1);
    STAT(h_hmem2__4=htab_memory(); h_omem2__4=other_memory();)
  }

  inline int yxlread(int in, i32* yxl, int L)
  {
    int l=tread(in,yxl,3*L);
    if(l<0) error("cannot read (%m)");
    return l/3;
  }

  inline void check_bindir(char* fname, char* bindir)
  {
    char newbindir[strlen(fname)+2]; strcpy(newbindir, fname);
    char* p=strrchr(newbindir,'/'); if(!p) strcpy(newbindir,"."); else *p=0;
    if(!same_file(bindir, newbindir)) error("file %s is not within a scope of directory %s", fname, bindir);
  }

  ctab__4(char* bp, char** file_list, char* bindir, int A0, int C)
  {
    i32 yxl[3*BLOCKSIZE];
    init_ctab(A0);
    for(char** f=file_list; *f; f++){
      check_bindir(*f,bindir);
      int in=open_infile(bp,*f);
      VERB(fprintf(stdmsg,"pass1: %-70s\r", *f);)
      if(in<0) error("cannot open file %s (%m)",*f);
      for(;;){
        int L=yxlread(in,yxl,BLOCKSIZE);
        if(L==0) break;
        acc_marginals(yxl, L); //acc_marginals() must be called before acc_tab()
      }                          //since it checks validity of input data in
      close(in);                 //subsequent runs we rely on the correctness of the
      bury_zombie();             //preprocessor, namely that it will return the same
    }                            //(therefore correct) data as in the first run.
    VERB(fprintf(stdmsg,"\n");)
    for(char** f=file_list; *f; f++){
      int in=open_infile(bp,*f);
      VERB(fprintf(stdmsg,"pass2: %-70s\r", *f);)
      if(in<0) error("cannot open file %s (%m)",*f);
      for(;;){
        int L=yxlread(in,yxl,BLOCKSIZE);
        if(L==0) break;
        acc_tab(yxl, L, 0, c0);  //first build of ctab is only used to compute 
      }                          //space demands (counts how many bigrams are there)
      close(in);
      bury_zombie();
    }
    VERB(fprintf(stdmsg,"\n");)
    determine_useful_size();     //compute yc and destroy original hash table
    for(char** f=file_list; *f; f++){
      int in=open_infile(bp,*f);
      VERB(fprintf(stdmsg,"pass3: %-70s\r", *f);)
      if(in<0) error("cannot open file %s (%m)",*f);
      for(;;){
        int L=yxlread(in,yxl,BLOCKSIZE);
        if(L==0) break;
        acc_tab(yxl, L, oversize, yc);
      }
      close(in);
      bury_zombie();
    }
    finish_ctab_init(C);
    VERB(fprintf(stdmsg,"\n");)
  }

  void merge_columns(i32 ll, i32 rr){
    if(epoch_ct==0) fill(epoch_guard,i32(0),A);
    epoch_ct++;
    DBG(if(ll>=rr) error("merge_columns(): %d<%d violated\n", ll, rr);)
    int l=c_map[ll], r=c_map[rr];
    int bfr[x_walk_size[rr]], bp=0;
    i32* x_walk_rr=x_walk[rr];
    for(int yp=0, yp_to=x_walk_size[rr]; yp<yp_to; yp++){
      i32 y=x_walk_rr[yp];
      y=live(y);
      if(epoch_guard[y]==epoch_ct) continue;
      epoch_guard[y]=epoch_ct;           /*c[y].L>0*/  DBG(if(c[y].L<=0) error("Internal error in merge_columns(): c[%d].L=%d<=0", y, c[y].L);)
      entry__4* hr=c[y].hash_qry(r);    /*always finds*/ DBG(if(!hr || hr->key<=0) error("Internal error in merge_columns(): 'always finds' violated y=%d (was %d) x=%d key=%d\n",y, x_walk[rr][yp], r, hr? hr->key:-2);)
      i32 d=hr->data;
      c[y].hash_del(hr);
      entry__4* hl=c[y].hash_qry(l); /*always non-null*/ DBG(if(!hl) error("Internal error in merge_columns(): `always non-null' violated");)
      if(hl->key<=0) {c[y].hash_ins(hl,l,d); bfr[bp++]=y;}
      else{
        hl->data+=d;
        if(c[y].occupied*rehash_trigger < c[y].L) c[y].rehash(oversize);
      }
    }
    dispose(x_walk[rr]); x_walk_size[rr]=0;
    if(bp>0){
      i32* new_x_walk; alloc(new_x_walk, x_walk_size[ll]+bp);
      copy(new_x_walk, x_walk[ll], x_walk_size[ll]);
      copy(new_x_walk+x_walk_size[ll], bfr, bp);
      x_walk_size[ll]+=bp;
      free(x_walk[ll]);
      x_walk[ll]=new_x_walk;
    }
  }
   
  void merge_rows(i32 ll, i32 rr){
    DBG(if(ll>=rr) error("Internal error in merge_rows(): %d<%d violated\n", ll, rr);)
    int l=c_map[ll], r=c_map[rr];
    if(c[l].L<0) c[l].move(c[r]);  /* calls the move-constructor 'c[l] <-- c[r]' */
    else if(c[r].L>0){
      hash__4* lh=&(c[l]), *rh=&(c[r]);
      int intersection=0;  /* compute intersection size */
      if(lh->occupied<rh->occupied) swap(lh,rh);    
      for(int k=0, rL=rh->L; k<rL; k++) {
        i32 rkey=rh->a[k].key;
        if(rkey>0){
          entry__4 *er=lh->hash_qry(rkey);
          if(er && er->key>0) intersection++;
        }
      }
      int s=0, S=lh->occupied+rh->occupied;
      entry__4 bfr[S];        /* save values */
      for(int k=0, lL=lh->L; k<lL; k++) if(lh->a[k].key>0) bfr[s++]=lh->a[k];
      for(int k=0, rL=rh->L; k<rL; k++) if(rh->a[k].key>0) bfr[s++]=rh->a[k];
      lh->done(); rh->done();
      lh=&(c[l]);
      lh->init(oversize, S-intersection);   /* create the merged row */ 
      for(s=0; s<S; s++){
        entry__4* e=lh->hash_qry(bfr[s].key);   DBG(if(!e) error("Internal error in merge_rows(): e!=null violated");)
        if (e->key<=0) lh->hash_ins(e,bfr[s].key,bfr[s].data);
        else e->data+=bfr[s].data;
      }
    }
  }
   
  void merge(i32 ll, i32 rr)
  {
    merge_columns(ll,rr);
    merge_rows(ll,rr);
    c0[ll]+=c0[rr]; c1[ll]+=c1[rr];
    Rc0[ll]=R(c0[ll]); Rc1[ll]=R(c1[ll]);
    alias[c_map[rr]]=c_map[ll];
    c_map[rr]=0;
  }

  inline i32 cd(i32 y, i32 x) {return c[y].hash_data(x);}
  
  inline ux yx2i(int y, int x) { return y+ux(x)*(x-1)/2; }  /* y<x */


  void apply_corrections(FF* loss, line__4* line_ab, int n_ab,   /* both non-zero */
                                   line__4* line_a,  int n_a,    /* b-part is zero */
                                   line__4* line_b,  int n_b)    /* a-part is zero */
  {
    for(int p=0; p<n_ab; p++){
      i32 lpa=line_ab[p].a, lpb=line_ab[p].b; F lpQ=line_ab[p].Q; i32 lpm=line_ab[p].map;
      for(int q=0; q<n_ab; q++){ 
        i32 lqm=line_ab[q].map;
        if(lpm<lqm)
          loss[yx2i(lpm,lqm)]+=lpQ+line_ab[q].Q-Q(lpa+line_ab[q].a, lpb+line_ab[q].b);
      }
      for(int q=0; q<n_a; q++){ 
        i32 lqm=line_a[q].map;
        if(lpm<lqm)
          loss[yx2i(lpm,lqm)]+=lpQ-Q(lpa+line_a[q].a, lpb);
      }
      for(int q=0; q<n_b; q++){ 
        i32 lqm=line_b[q].map;
        if(lpm<lqm)
          loss[yx2i(lpm,lqm)]+=lpQ-Q(lpb+line_b[q].b, lpa);
      }
    }

    for(int p=0; p<n_a; p++){
      i32 lpa=line_a[p].a; i32 lpm=line_a[p].map;
      for(int q=0; q<n_ab; q++){ 
        i32 lqm=line_ab[q].map;
        if(lpm<lqm)
          loss[yx2i(lpm,lqm)]+=line_ab[q].Q-Q(lpa+line_ab[q].a, line_ab[q].b);
      }
      for(int q=0; q<n_b; q++){ 
        i32 lqm=line_b[q].map;
        if(lpm<lqm)
          loss[yx2i(lpm,lqm)]-=Q(line_b[q].b, lpa);
      }
    }

    for(int p=0; p<n_b; p++){
      i32 lpb=line_b[p].b; i32 lpm=line_b[p].map;
      for(int q=0; q<n_ab; q++){ 
        i32 lqm=line_ab[q].map;
        if(lpm<lqm)
          loss[yx2i(lpm,lqm)]+=line_ab[q].Q-Q(line_ab[q].a, lpb+line_ab[q].b);
      }
      for(int q=0; q<n_a; q++){ 
        i32 lqm=line_a[q].map;
        if(lpm<lqm)
          loss[yx2i(lpm,lqm)]-=Q(line_a[q].a, lpb);
      }
    }    
  }

  void I_corrections(FF* loss, i32 ll, i32 rr)
  {
    i32 l=c_map[ll], r=c_map[rr];
    line__4 line_ab[C]; 
    line__4 line_a[C]; 
    line__4 line_b[C]; 
    
    int n_ab=0, n_a=0, n_b=0;              /*!!!!!!! tady budu potrebovat inv_cmap !!! */
    for(int p=0; p<C; p++) if(p!=ll && p!=rr && c_map[p]>0) {
      i32 a=cd(l,c_map[p]), b=cd(r,c_map[p]);    
      if(a!=0 && b!=0) {
        line_ab[n_ab].a=a; line_ab[n_ab].b=b; 
        line_ab[n_ab].Q=Q(a,b); line_ab[n_ab].map=p;
        n_ab++;
      }else if(a!=0){
        line_a[n_a].a=a; line_a[n_a].map=p;
        n_a++;
      }else if(b!=0){
        line_b[n_b].b=b; line_b[n_b].map=p;
        n_b++;
      }
    }
    apply_corrections(loss, line_ab, n_ab, line_a, n_a, line_b, n_b);
    
    n_ab=0, n_a=0, n_b=0;
    for(int p=0; p<C; p++) if(p!=ll && p!=rr && c_map[p]>0) {
      i32 a=cd(c_map[p], l), b=cd(c_map[p], r);
      if(a!=0 && b!=0) {
        line_ab[n_ab].a=a; line_ab[n_ab].b=b; 
        line_ab[n_ab].Q=Q(a,b); line_ab[n_ab].map=p;
        n_ab++;
      }else if(a!=0){
        line_a[n_a].a=a; line_a[n_a].map=p;
        n_a++;
      }else if(b!=0){
        line_b[n_b].b=b; line_b[n_b].map=p;
        n_b++;
      }
    }
    apply_corrections(loss, line_ab, n_ab, line_a, n_a, line_b, n_b);
  }

  F I_loss(i32 l, i32 r)
  {
    if(epoch_ct==0) fill(epoch_guard,i32(0),A);
    epoch_ct++;
    int ml=c_map[l], mr=c_map[r];
    i32 cll=cd(ml,ml), clr=cd(ml,mr), crl=cd(mr,ml), crr=cd(mr,mr);
    F base = R(c0[l]+c0[r]) - Rc0[l] - Rc0[r] + R(c1[l]+c1[r]) - Rc1[l] - Rc1[r]
           + R(cll+clr) + R(crl+crr) + R(cll+crl) + R(clr+crr)
           - R(cll)-R(clr)-R(crl)-R(crr)-R(cll+clr+crl+crr);
    F acc=0;
    if(c[ml].occupied < c[mr].occupied) {swap(ml,mr);swap(l,r);}
    for(int p=c[mr].L-1; p>=0; p--){
      i32 x=c[mr].a[p].key;
      if(x>0){
        i32 clx=cd(ml,x);
        if(clx>0){              /* update is non-zero in the intersection only */
          F crx=c[mr].a[p].data;
          F alfa=clx/F(clx+crx), beta=1-alfa;   /* beta=crx/(clx+crx) */
          acc+=clx*ulog2(alfa) + crx*ulog2(beta);  
        }
      }
    }    
    if(x_walk_size[l]<x_walk_size[r]) {swap(l,r);swap(ml,mr);}
    int q=0;
    for(int p=0; p<x_walk_size[r]; p++){
      int y=live(x_walk[r][p]);
      y=live(y);
      if(epoch_guard[y]==epoch_ct) continue;
      epoch_guard[y]=epoch_ct;
      x_walk[r][q++]=y;      
      int cyl=cd(y,ml);
      if(cyl>0){
        int cyr=cd(y,mr);
        F alfa=cyl/F(cyl+cyr), beta=1-alfa;
        acc+=cyl*ulog2(alfa) + cyr*ulog2(beta); 
      }
    }
    x_walk_size[r]=q;
    return base+acc;
  }
  
  void build_mmi_tree(int start_time, FILE* log, mmi_result& ret)
  {
    VERB(fprintf(stdmsg,"Table constructed. A=%d B=%d C=%d L=%lld. Computing loss table.\n", A, B, C, N);)
    tree t000; t000.l=0; t000.r=0; t000.level=0;
    alloc(ret.forest, A+C-1); fill(ret.forest, t000, A);
    alloc(ret.loss, C-1);
    ret.I=I; ret.A=A; ret.B=B; ret.C=C;
  #ifdef PROGRESS_LOG
    F totI=ret.I;
    if(log){
      fprintf(log,"#%5s %30s %30s %5s\n", "index", "MI_loss", "MI", "level");
      fprintf(log,"%6d %30.28f %30.28f %5d\n", A-1, 0.0, D(totI), 0);
    }
  #endif
    int out_map[C]; copy(out_map, c_map, C);
    FF loss[ux(C-1)*C/2];  /* to be indexed by yx2i */ //predelat na alloc --- aby to hlasilo chybu pri preteceni
    for(int x=1; x<C; x++) for(int y=0; y<x; y++) loss[yx2i(y,x)]=I_loss(y,x);
    VERB(fprintf(stdmsg,"initial loss table computed, starting iterations...\n"));
    for(int n=A; n<A+C-1; n++){
      int l=0,r=1;
      FF min_loss=F_max(FF(1));
      for(int x=1; x<C; x++) if(c_map[x]>0) for(int y=0; y<x; y++) if(c_map[y]>0 && min_loss>loss[yx2i(y,x)]){
        min_loss=loss[yx2i(y,x)];
        l=y; r=x;
      }
      VERB(fprintf(stdmsg,"step %d of %d: merging %d %d  --> %d            \r", n-A+1, C-1, out_map[l], out_map[r], n));
      I_corrections(loss,l,r);
      merge(l,r);
      ret.forest[n].l=out_map[l]; ret.forest[n].r=out_map[r]; ret.loss[n-A]=min_loss/N;
  #ifdef PROGRESS_LOG
      if(log){
        ret.forest[n].level=1+max(ret.forest[out_map[l]].level, ret.forest[out_map[r]].level);
        totI-=min_loss/N;
        fprintf(log,"%6d %30.28f %30.28f %5d\n", n, D(min_loss/N), D(totI), ret.forest[n].level);
        fflush(log);
      }
  #endif
      for(int y=0; y<C; y++) if(y!=l && c_map[y]>0){
        int p=y, q=l;
        if (p>q) swap(p,q);
        loss[yx2i(p,q)]=I_loss(p,q);
      }
      out_map[l]=n;
    }
    VERB(fprintf(stdmsg,"\n"
         "mmi_clustering__4(): Finished in %d seconds.\n", int(time(0))-start_time);)
  #ifdef STATISTICS
    VERB(fprintf(stdmsg,
         " probe hash table's insert count = %Ld, collisions per insert = %4.2f\n"
         "      allocated entry count = %Ld,  size=%4.2f MB\n"
         " main hash table's insert count = %Ld, collisions per insert = %4.2f\n"
         "      allocated entry count = %Ld,  size=%4.2f + %4.2f MB\n"
         "      access count = %Ld, collisions per access = %4.2f\n"
         "      rehash count = %Ld\n",
         h_access_build1__4, D(h_collision_build1__4)/h_access_build1__4,
         h_size1__4, D(h_hmem1__4)/1024/1024,
         h_access_build2__4, D(h_collision_build2__4)/h_access_build2__4,
         h_size2__4, D(h_hmem2__4)/1024/1024, D(h_omem2__4)/1024/1024,
         h_access__4, D(h_collision__4)/h_access__4, h_rehash__4);)
  #endif
  }
};

void mmi_clustering__4(FILE* out_log, char* bp, char**file_list, char*bindir, int A0, int C, mmi_result&r)
{
  int start_time=time(0);
  VERB(fprintf(stdmsg,"Loading data and building bigram table...\n");)
  ctab__4 c(bp, file_list, bindir, A0, C);
  c.build_mmi_tree(start_time, out_log, r);
}

/*
void mmi_clustering__4(i32* w0, i32* w1, int N, int T, mmi_result &ret)  //for compatibility with `check'
{
  i32 w[2*N];
  for(int k=0; k<N; k++) {w[2*k]=w0[k]; w[2*k+1]=w1[k];}
  mmi_clustering_4(w,2*N,2,1,1<<30,T,ret,0, A0!!!!!);
}
*/

