
/* ---- this file comes from `daves_core' package
 * Place #include <nothreads.h> after you include stdio.h (note that it is included in 
 * inc.h and os.cc. If nothreads.h is included, you the thread safe (but slow) I/O is 
 * turned off. This means that it is dangerous to include nothreads.h in multi-threaded program.
 */


#ifndef NOTHREADS_H
#define NOTHREADS_H

#undef getc
#undef putc
#undef getchar
#undef putchar 

#define fgetc(fp) _IO_getc_unlocked (fp)
#define fputc(c, fp) _IO_putc_unlocked ((c), (fp))

#define getc(fp) _IO_getc_unlocked (fp)
#define getchar() _IO_getc_unlocked (stdin)
#define putc(c, fp) _IO_putc_unlocked ((c), (fp))
#define putchar(c) _IO_putc_unlocked ((c), stdout)

#define fflush(fp) fflush_unlocked (fp)
//#define fread(a,b,c,d) fread_unlocked ((a),(b),(c),(d))
//#define fwrite(a,b,c,d) fwrite_unlocked ((a),(b),(c),(d))


#endif


